package asignacionServlet;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import m05bClasses.m05bComun;
import m05bClasses.m05bConexion;
import m05bClasses.m05bConstantes;
import m05bClasses.m05bFileLog;

import org.apache.fop.apps.Driver;
import org.apache.fop.apps.FOPException;
import org.xml.sax.InputSource;

public class m05bImpAsignacionNoDevueltaServlet extends
		javax.servlet.http.HttpServlet {
	java.sql.Connection conn = null;
	String sLinea;
	String sFoFileDir = "/datos/m05b/tmp/";
	File foFileDir;
	File tmpFoFile;
	FileOutputStream tmpFoFileStream;
	m05bComun miComun = new m05bComun();
	m05bFileLog miLog = new m05bFileLog();
	String sSituacion = "";
	String sFecHasta = "";
	String sDesDpto = "";
	String sGRango = "";
	String sRango = "";
	String sPermanente = "";
	public static final String FO_REQUEST_PARAM = "fo";

	// Logger log = null;

	public void doPost(javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response)
			throws javax.servlet.ServletException, java.io.IOException {
		try {
			doGet(request, response);
		} catch (Exception e) {
			m05bFileLog miLog = new m05bFileLog();
	    	miLog.addTraza(e);
		}
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		performTask(request, response);
	}

	// if(log == null)
	// {
	// Hierarchy hierarchy = Hierarchy.getDefaultHierarchy();
	// log = hierarchy.getLoggerFor("fop");
	// log.setPriority(Priority.WARN);
	// }

	private void fncAbrirFicheroTemporal() throws java.io.IOException {
		foFileDir = new File(sFoFileDir);
		tmpFoFile = File.createTempFile("m05b", "Fo", foFileDir);
		tmpFoFileStream = new FileOutputStream(tmpFoFile);

	}

	private void fncImprimirFinPagina() throws java.io.IOException {
		sLinea = "	    </fo:table-body>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "       </fo:table>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      </fo:flow>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "   </fo:page-sequence>\n";
		tmpFoFileStream.write(sLinea.getBytes());

	}

	private void fncImprimirComienzoPagina(ResourceBundle res, String idioma)
			throws java.io.IOException, javax.naming.NamingException {
		// PAGE-SEQUENCE DEL LISTADO
		sLinea = "<fo:page-sequence master-reference=\"general\">\n";
		tmpFoFileStream.write(sLinea.getBytes());

		// REGION BEFORE
		sLinea = "		<fo:static-content flow-name=\"xsl-region-before\" >\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// -------------- CABECERA DEL LISTADO --------------
		// Cabecera 1
		sLinea = "      <fo:block font-size=\"16pt\" font-weight=\"bold\" padding-top=\"10pt\">\n <![CDATA["
				+ res.getString("infAsigNoDev.titulo")
				+ "]]></fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\" >\n <![CDATA["
				+ res.getString("infAsigNoDev.texto1") + sFecHasta + "]]></fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\">\n <![CDATA["
				+ res.getString("infAsigNoDev.texto2") + sDesDpto + "]]></fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		if (sPermanente.equals("1")) {
			sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\" >\n "
					+ res.getString("infAsigNoDev.texto3")+"  </fo:block>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		} else if (sPermanente.equals("2")) {
			sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\" >\n "
					+ res.getString("infAsigNoDev.texto3")+"</fo:block>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		}
		if (!(sRango.equals(""))) {
			sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\" >\n <![CDATA["
					+ res.getString("infAsigNoDev.texto4") + sRango + "]]></fo:block>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		} else if (!(sGRango.equals(""))) {
			sLinea = "      <fo:block font-weight=\"bold\" padding-top=\"5pt\" font-size=\"9pt\" >\n <![CDATA["
					+res.getString("infAsigNoDev.texto5") + sGRango + "]]></fo:block>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		}
		sLinea = " 		</fo:static-content>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// PIE DE PAGINA Pie
		sLinea = "		<fo:static-content flow-name=\"xsl-region-after\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// PIE DE PAGINA Pie
		sLinea = "      <fo:block >\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "       <fo:table table-layout=\"fixed\" width=\"160mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"80mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"80mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-body font-family=\"Helvetica\" font-size=\"6pt\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-cell >\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block text-align=\"left\">"
				+ miComun.getDetFechaActual(idioma) + "</fo:block>";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-cell >\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block text-align=\"right\">";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = res.getString("pagina")+" <fo:page-number/> \n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "</fo:block>";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-body>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "       </fo:table>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      </fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = " 		</fo:static-content>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// BODY
		sLinea = "	<fo:flow flow-name=\"xsl-region-body\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// -------------- DETALLE DEL LISTADO --------------
		sLinea = "        <fo:table table-layout=\"fixed\" width=\"250mm\" space-after.optimum=\"12pt\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"30mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"30mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"90mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"30mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"35mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"20mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-column column-width=\"20mm\"/>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-body font-family=\"Helvetica\" font-size=\"8pt\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// Matrícula
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\"  text-align=\"center\">\n "+res.getString("infAsigNoDev.col1")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// Cargo
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\" text-align=\"center\">\n "+res.getString("infAsigNoDev.col2")
				+ "</fo:block>";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// Nombre
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\" text-align=\"center\">\n "+res.getString("infAsigNoDev.col3")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// Marca
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\"  text-align=\"center\">\n "+res.getString("infAsigNoDev.col4")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// Modelo
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\" text-align=\"center\">\n "+res.getString("infAsigNoDev.col5")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// F.Inicio
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\"  text-align=\"center\">\n "+res.getString("infAsigNoDev.col6")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// F.Hasta
		sLinea = "	    <fo:table-cell padding-top=\"2mm\">\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "      <fo:block font-weight=\"bold\" font-size=\"7pt\"  text-align=\"center\">\n "+res.getString("infAsigNoDev.col7")+"</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    <fo:table-row >\n";
		tmpFoFileStream.write(sLinea.getBytes());

	}

	private void imprimirTotal(int intCont, boolean bolGeneral,
			ResourceBundle res) throws java.io.IOException,
			javax.naming.NamingException {
		sLinea = "	    <fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		// vacías
		for (int i = 0; i < 4; i++) {
			sLinea = "	    <fo:table-cell>\n<fo:block>\n</fo:block>\n</fo:table-cell>\n";
			tmpFoFileStream.write(sLinea.getBytes());
		}
		// Contador
		sLinea = "	    <fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		if (bolGeneral)
			sLinea = "      <fo:block font-weight=\"bold\" text-align=\"right\"  padding-top=\"26pt\">\n "
					+ res.getString("infAsigDat.texto6") + intCont + "</fo:block>\n";
		else
			sLinea = "      <fo:block font-weight=\"bold\" text-align=\"right\"  padding-top=\"26pt\">\n "
					+ res.getString("infAsigDat.texto7") + intCont + "</fo:block>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-cell>\n";
		tmpFoFileStream.write(sLinea.getBytes());
		sLinea = "	    </fo:table-row>\n";
		tmpFoFileStream.write(sLinea.getBytes());
	}

	public void performTask(javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response)
			throws ServletException {
		java.sql.Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		m05bComun miComun = new m05bComun();
		sDesDpto = "";
		String sCodDpto = "";
		String sCodDptoAnt = "";
		String sNombre = "";
		String sUsuario = "";
		String sFechaHasta = "";
		String sFechaDesde = "";
		String sCargo = "";
		String sMarca = "";
		String sModelo = "";
		String sMatricula = "";
		String sDesDptoAnt = "";

		try {
			HttpSession session = request.getSession(true);

			/* Iker. idioma */
			Locale idiomaLocal = (Locale) session.getAttribute("Local");
			String idiomaSes = ((idiomaLocal.getLanguage() == null) ? "es"
					: idiomaLocal.getLanguage());
			String campoTexto = "";
			String campoTexto2 = "";
			String campoTexto3 = "C";
			String formatoFecha="dd/MM/yyyy";
			ResourceBundle res = (ResourceBundle) session
					.getAttribute("resTit");
			if (!idiomaSes.equals("es")) {
				campoTexto = "E";
				campoTexto2 = "E_";
				campoTexto3 = "E";
				formatoFecha="yyyy/MM/dd";
			}

			m05bConexion miConex = new m05bConexion();
			conn = miConex.getConnection();

			// Obtención de información de BD
			// Vehículo
			// Recogemos la situacion
			sCodDptoAnt = "";
			sSituacion = request.getParameter("Situacion");
			if ((sSituacion == null) || (sSituacion.equals(""))) {
				sSituacion = "";
			} else {
				sSituacion = miComun.ListaCaracteres(sSituacion);
			}
			// Recogemos Fecha Hasta:
			sFecHasta = request.getParameter("FecHasta");
			if (sFecHasta == null) {
				sFecHasta = "";
			}
			// Recogemos el Grupo Rango
			sGRango = request.getParameter("GRango");
			if ((sGRango == null) || (sGRango.equals(""))) {
				sGRango = "";
			}
			// Recogemos el Rango
			sRango = request.getParameter("Rango");
			if ((sRango == null) || (sRango.equals(""))) {
				sRango = "";
			}
			// Recogemos Permanente
			sPermanente = request.getParameter("Permanente");
			if ((sPermanente == null) || (sPermanente.equals(""))) {
				sPermanente = "";
			}
			String sSentenciaPersonal = "";
			String sSentencia = "SELECT " + m05bConstantes.COL_01_CODDPTO + ",NVL("
					+ campoTexto2+m05bConstantes.COL_06_DESCDPTO + ","+m05bConstantes.COL_06_DESCDPTO +") ,NVL("
					+ campoTexto+m05bConstantes.COL_04_DESCCARG + ","+m05bConstantes.COL_04_DESCCARG +"),"
					+ m05bConstantes.COL_21_NOMBRE + ",NVL(M."
					+ campoTexto+m05bConstantes.COL_99_DESCRIPCION+",M."+m05bConstantes.COL_99_DESCRIPCION  + "),"
					+ m05bConstantes.COL_17_DESCRIP + ","
					+ m05bConstantes.COL_01_MATRICULA + ",TO_CHAR("
					+ m05bConstantes.COL_01_FDESDE + ",'"+formatoFecha+"'),TO_CHAR("
					+ m05bConstantes.COL_01_FHASTA + ",'"+formatoFecha+"'),"
					+ m05bConstantes.COL_01_FINALIZA + ","
					+ m05bConstantes.COL_34_SITUACION + " FROM  "
					+ m05bConstantes.TAB_ASIGNACION + ","
					+ m05bConstantes.TAB_DEPARTAMENTOS + ","
					+ m05bConstantes.TAB_CARGOS + ","
					+ m05bConstantes.TAB_PERSONAL + ","
					+ m05bConstantes.TAB_MODELOS + ","
					+ m05bConstantes.TAB_DESCRIPCIONES + "  M,"
					+ m05bConstantes.TAB_VEHICULOS + " WHERE "
					+ m05bConstantes.COL_01_MATRICULA + "="
					+ m05bConstantes.COL_34_MATRICULA + " AND "
					+ m05bConstantes.COL_01_CODDPTO + "="
					+ m05bConstantes.COL_06_CODDPTO + " AND "
					+ m05bConstantes.COL_34_MODELO + "="
					+ m05bConstantes.COL_17_CODMOD + " AND M."
					+ m05bConstantes.COL_99_CODTABLA + "(+)="
					+ m05bConstantes.DESC_MARCAS + " AND "
					+ m05bConstantes.COL_34_MARCA + "= M."
					+ m05bConstantes.COL_99_CODDESC + "(+) AND "
					+ m05bConstantes.COL_01_DNI + "="
					+ m05bConstantes.COL_21_DNI + "(+) AND "
					+ m05bConstantes.COL_01_CODCARGO + "="
					+ m05bConstantes.COL_04_CODCARGO + "(+) AND "
					+ m05bConstantes.COL_01_FINALIZA + "='N'";

			if (!(sSituacion.equals(""))) {
				sSentencia = sSentencia + " AND "
						+ m05bConstantes.COL_34_SITUACION + " in ("
						+ sSituacion + ")";
			}
			if (!(sFecHasta.equals(""))) {
			
				if (sPermanente.equals("1")) {
					sSentencia = sSentencia + " AND "
							+ m05bConstantes.COL_01_ASIG + " = 'S'";
				} else if (sPermanente.equals("2")) {
					sSentencia = sSentencia + " AND "
							+ m05bConstantes.COL_01_ASIG + " = 'N'";
				}
				if (!(sRango.equals(""))) {
					sSentencia = sSentencia + " AND "
							+ m05bConstantes.COL_34_RANGO + " = '" + sRango
							+ "'";
				} else if (!(sGRango.equals(""))) {
					String sSentenciaGrupo = " SELECT "
							+ m05bConstantes.COL_36_RANGOS + " FROM "
							+ m05bConstantes.TAB_GRUPOS + " WHERE "
							+ m05bConstantes.COL_36_CODIGO + " = '" + sGRango
							+ "'";
					pstmt = conn.prepareStatement(sSentenciaGrupo);
					rs = pstmt.executeQuery();
					if (rs.next()) {
						sGRango = rs.getString(1) == null ? "" : rs
								.getString(1);
						sGRango = miComun.ListaCaracteres(sGRango);
						sSentencia = sSentencia + " AND "
								+ m05bConstantes.COL_34_RANGO + " in ( "
								+ sGRango + ")";

					}
				}

				sSentencia = sSentencia + " AND TO_CHAR("
						+ m05bConstantes.COL_01_FHASTA + ",'"+formatoFecha+"')<= '"
						+ sFecHasta + "'";
			}
			sSentencia = sSentencia + " ORDER BY "
					+ m05bConstantes.COL_01_CODDPTO + ","
					+ m05bConstantes.COL_04_DESCCARG;
			miLog.addTraza("Bego", "m05b - ImpAsignacionNoDevuelta:  ",
					"sSentencia: " + sSentencia, m05bConstantes.LOG_NIVEL_BAJO);
		
			pstmt = conn.prepareStatement(sSentencia);
			rs = pstmt.executeQuery();

			String xlnetsini = miComun.leerPropiedad("xlnets");
			// String urlprin = xlnetsini.substring(0, xlnetsini.indexOf("/",
			// 8));

			fncAbrirFicheroTemporal();

			sLinea = "<?xml version=\"1.0\" encoding=\"windows-1252\"?>\n";
			tmpFoFileStream.write(sLinea.getBytes());

			sLinea = "<fo:root xmlns:fo=\"http://www.w3.org/1999/XSL/Format\">\n";
			tmpFoFileStream.write(sLinea.getBytes());
			// LAYOUT DEL LISTADO
			sLinea = "<fo:layout-master-set>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "	<fo:simple-page-master master-name=\"general\"  page-height=\"21cm\" page-width=\"29.5cm\" margin-top=\"2cm\" margin-bottom=\"2cm\" margin-left=\"2cm\" margin-right=\"2.5cm\">\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "		<fo:region-before extent=\"3.5cm\"/>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "		<fo:region-body  margin-top=\"3.6cm\" margin-bottom=\"1.5cm\" />\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "		<fo:region-after  extent=\"1cm\"/>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "		<fo:region-start extent=\"0cm\"/>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "		<fo:region-end extent=\"0cm\"/>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "	</fo:simple-page-master>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			sLinea = "</fo:layout-master-set>\n";
			tmpFoFileStream.write(sLinea.getBytes());
			int cont = 0;
			// Agurtzane Mar12: contador en listados
			int intCont = 0, intContParcial = 0;
			// Fin Agurtzane Mar12: contador en listados
			while (rs.next()) {
				// Agurtzane Mar12: contador en listados
				intCont++;
				intContParcial++;
				// Fin Agurtzane Mar12: contador en listados
				sDesDpto = rs.getString(2) == null ? "" : rs.getString(2);
				sCodDpto = rs.getString(1) == null ? "" : rs.getString(1);
				sMatricula = rs.getString(7) == null ? "" : rs.getString(7);
				sFechaDesde = rs.getString(8) == null ? "" : rs.getString(8);
				sFechaHasta = rs.getString(9) == null ? "" : rs.getString(9);
				sMarca = rs.getString(5) == null ? "" : rs.getString(5);
				sModelo = rs.getString(6) == null ? "" : rs.getString(6);
				sNombre = rs.getString(4) == null ? "" : rs.getString(4);
				sCargo = rs.getString(3) == null ? "" : rs.getString(3);

				if (((!(sCodDpto.equals(sCodDptoAnt)))) || (cont == 30)) {
					if (!(sCodDptoAnt.equals(""))) {
						imprimirTotal(intContParcial, false, res);// Agurtzane
																	// Mar12:
																	// contador
																	// en
																	// listados

						fncImprimirFinPagina();
					}
					fncImprimirComienzoPagina(res, campoTexto3);
					cont = 0;
					intContParcial = 0;// Agurtzane Mar12: contador en listados
				} else {
					cont = cont + 1;
					sLinea = "	    <fo:table-row >\n";
					tmpFoFileStream.write(sLinea.getBytes());
				}
				sCodDptoAnt = sCodDpto;
				// Matricula
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA["
						+ sMatricula + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// Cargo
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n <![CDATA["
						+ sCargo + "]]></fo:block>";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// Nombre
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA[ "
						+ sNombre + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// Marca
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA["
						+ sMarca + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// Modelo
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA["
						+ sModelo + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// FecDesde
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA["
						+ sFechaDesde + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				// FecHasta
				sLinea = "	    <fo:table-cell font-size=\"8pt\" padding-top=\"0.2mm\" border-width=\"0.1mm\" border-style=\"solid\">\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "      <fo:block  font-size=\"8pt\"  text-align=\"left\">\n<![CDATA["
						+ sFechaHasta + "]]></fo:block>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-cell>\n";
				tmpFoFileStream.write(sLinea.getBytes());
				sLinea = "	    </fo:table-row>\n";
				tmpFoFileStream.write(sLinea.getBytes());
			}
			// Agurtzane Mar12: contador en listados
			intContParcial++;
			imprimirTotal(intContParcial, false, res);
			imprimirTotal(intCont, true, res);
			// Fin Agurtzane Mar12: contador en listados
			fncImprimirFinPagina();
			rs.close();

			sLinea = "</fo:root>\n";
			tmpFoFileStream.write(sLinea.getBytes());

			tmpFoFileStream.close();

			// FileInputStream file = new FileInputStream(sFoFileDir +
			// tmpFoFile.getName());

			// renderFO(new InputSource(file), response);
			generarPDFdesdeFO(sFoFileDir + tmpFoFile.getName(), sFoFileDir,
					response);

			// tmpFoFile.delete();

			// response.flushBuffer();

		} catch (Exception ex) {
			try {
				response.sendRedirect("m05bError.jsp");
			} catch (IOException e) {
				// TODO Auto-generated catch block
				m05bFileLog miLog = new m05bFileLog();
		    	miLog.addTraza(e);
			}
		} finally {
			try {
				if (rs != null)
					rs.close();
				if (pstmt != null)
					pstmt.close();
				if (conn != null)
					conn.close();
			} catch (SQLException e2) {
				try {
					response.sendRedirect("m05bError.jsp");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					miLog.addTraza(e);
				}
			}
		}
	}

	/**
	 * renders an FO inputsource into a PDF file which is rendered directly to
	 * the response object's OutputStream
	 */
	public void renderFO(InputSource foFile, HttpServletResponse response)
			throws ServletException {
		try {
			ByteArrayOutputStream out = new ByteArrayOutputStream();

			response.reset();
			OutputStream oOut = response.getOutputStream();
			BufferedOutputStream bOut = new BufferedOutputStream(oOut);
			Driver driver = new Driver(foFile, out);
			driver.setRenderer(Driver.RENDER_PDF);
			driver.run();

			response.setContentLength(out.size());
			response.setContentType("application/pdf");

			bOut.write(out.toByteArray());
			out.close();
			bOut.flush();
			bOut.close();
			// response.flushBuffer();
		} catch (Exception ex) {
			throw new ServletException(ex);
		}
	}

	public void generarPDFdesdeFO(String ficheroFO, String rutaPDF,
			HttpServletResponse response) throws FOPException {
		try {

			Driver driver = new Driver();

			driver.setRenderer(Driver.RENDER_PDF);

			// Si no existe el directrio lo crea
			File f = new File(rutaPDF);

			if (!f.exists()) {

				f.mkdir();

			}
			// Cargar los datos del .FO
			FileInputStream file = new FileInputStream(ficheroFO);

			BufferedInputStream bfile = new BufferedInputStream(file);

			driver.setInputSource(new InputSource(bfile));

			// Crear un temporal que va a ser el .pdf
			String sPdfFileDir = rutaPDF;
			File pdfFileDir = new File(sPdfFileDir);
			File tmpPdfFile = File.createTempFile("m05b", ".pdf", pdfFileDir);

			FileOutputStream fileout = new FileOutputStream(tmpPdfFile);

			BufferedOutputStream bfileout = new BufferedOutputStream(fileout);

			driver.setOutputStream(bfileout);

			driver.run();

			bfile.close();

			bfileout.close();
			// Longitus del Fichero PDF.
			Long longitud = new Long(tmpPdfFile.length());
			String sLongitud = "" + longitud;
			int iLongitud = Integer.parseInt(sLongitud);

			response.setContentLength((int) iLongitud);
			response.setContentType("application/pdf");

			byte[] fileBytes = new byte[longitud.intValue()];
			FileInputStream fisficheroPdf = new FileInputStream(tmpPdfFile);
			fisficheroPdf.read(fileBytes);
			ServletOutputStream os = response.getOutputStream();
			((OutputStream) os).write(fileBytes);
			((OutputStream) os).flush();
			((OutputStream) os).close();

			// BORRAR EL FICHERO FO

			File fichero = new File(ficheroFO);
			boolean borrado = fichero.delete();
			boolean borrado2 = tmpPdfFile.delete();

		} catch (Exception e) {
			System.err.println("EXCEPCION !!! : Error pasando de FO a PDF: "
					+ e);
		}

	}

}